/* ==================================== JUCER_BINARY_RESOURCE ====================================

   This is an auto-generated file: Any edits you make may be overwritten!

*/

#include <cstring>

namespace BinaryData
{

//================== Terrain.vert ==================
static const unsigned char temp_binary_data_3[] =
"attribute vec3 position;\n"
"\n"
"uniform mat4 projectionMatrix;\n"
"uniform mat4 viewMatrix;\n"
"\n"
"uniform int terrainIndex;\n"
"\n"
"uniform float a;\n"
"uniform float b;\n"
"uniform float c;\n"
"uniform float d;\n"
"uniform float saturation;\n"
"\n"
"out float depth;\n"
"out vec3 normal;\n"
"out vec3 fragmentPosition;\n"
"\n"
"float pi = 3.14159265359;\n"
"float e =  2.71828;\n"
"float saturate (float signal, float scale)\n"
"{\n"
"    return tanh(signal * scale * 1.31303528551);\n"
"}\n"
"\n"
"float calculateDepth (int index, vec2 p)\n"
"{\n"
"    float outputValue = 0.0;\n"
"    switch (index)\n"
"    {\n"
"        case 0:\n"
"            outputValue = sin(p.x * 6.0 * (a + 0.5)) * sin(p.y * 6.0 * (b + 0.5));\n"
"        break;\n"
"        case 1:\n"
"            outputValue = sin((p.x * pi * 2.0) * (p.x * 3.0 * a) + (b * pi * 2.0)) * sin((p.y * pi * 2.0) * (p.y * 3.0 * a) + (b * -pi * 2));       \n"
"        break;\n"
"        case 2: \n"
"            outputValue = cos(distance(vec2 (p.x, p.y), vec2(0.0, 0.0)) * pi * 2.0 * (a * 5.0 + 1.0) + (b * pi * 2.0)); \n"
"        break;\n"
"        case 3:\n"
"        {\n"
"            float c = a * 14.0 + 1.0;\n"
"            outputValue =  (1.0 - (p.x * p.y)) * cos(c * (1.0 - p.x * p.y));\n"
"        }\n"
"        break;\n"
"        case 4:\n"
"        {\n"
"            float c = a * 0.5 + 0.25;\n"
"            float d = b * 16.0 + 4.0;\n"
"            outputValue = c * p.x * cos((1.0 - c) * d * pi * p.x * p.y)  +  (1.0 - c) * p.y * cos(c * d * pi * p.x * p.y);\n"
"        }\n"
"        break;\n"
"        case 5:\n"
"        {\n"
"            float aa = a * 4.0 + 1.0;\n"
"            float bb = b * 4.0 + 1.0;\n"
"            float cc = c * 0.8 + 0.1; //c * 1.5 + 2.6;\n"
"            outputValue =  ((pow (aa * p.x, 2.0) + pow (bb * p.y, 2.0)) * \n"
"                             pow (cc, (pow (4.0 * p.x, 2.0) + \n"
"                                       pow (4.0 * p.y, 2.0)))) * 2.0 - 1.0;\n"
"        }\n"
"        break;\n"
"        case 6: // System 12\n"
"        {\n"
"            float aa = a * 4.0 + 1.0;\n"
"            float bb = b * 4.0 + 1.0;\n"
"            outputValue = sin (pow (aa * p.x, 2.0) + pow (bb * p.y, 2.0));\n"
"        }\n"
"        break;\n"
"        case 7: // System 14\n"
"        {   \n"
"            float aa = a * 36.0 + 6.0;\n"
"            float bb = b * 2.0 - 1.0;\n"
"            float cc = c * 2.0 - 1.0;\n"
"            outputValue = cos(aa * sin (sqrt (pow (p.x + bb, 2.0) + pow (p.y + cc, 2.0))));\n"
"        }\n"
"        break;\n"
"        case 8: // System 15\n"
"        {\n"
"            float aa = a * 36.0;\n"
"            outputValue = cos ((aa * sin (sqrt (pow (p.x + 1.1, 2.0) + pow (p.y + 1.1, 2.0)))) - (4.0 * atan ((p.y + 1.1) / (p.x + 1.1))));\n"
"        }\n"
"        break;\n"
"\n"
"        default:\n"
"            outputValue = 0.0;\n"
"    }\n"
"    outputValue = saturate (outputValue, saturation);\n"
"    return outputValue;\n"
"}\n"
"\n"
"// https://stackoverflow.com/questions/13983189/opengl-how-to-calculate-normals-in-a-terrain-height-grid\n"
"vec3 calculateNormal (int index, vec2 p)\n"
"{\n"
"    vec3 offset = vec3(0.05, 0.05, 0.0);\n"
"    float hL = calculateDepth (index, p - offset.xz);\n"
"    float hR = calculateDepth (index, p + offset.xz);\n"
"    float hD = calculateDepth (index, p - offset.zy);\n"
"    float hU = calculateDepth (index, p + offset.zy);\n"
"\n"
"    vec3 n;\n"
"    n.x = hL - hR;\n"
"    n.y = hD - hU;\n"
"    n.z = 2.0; // no idea why 2 hmmmm\n"
"    n = normalize (n);\n"
"    return n;\n"
"}\n"
"\n"
"void main()\n"
"{\n"
"    depth = calculateDepth (terrainIndex, vec2(position.x, position.y));\n"
"    vec4 adjustedPosition = vec4(position.x, position.y, depth * 0.3, 1.0);\n"
"    depth = 1.0 - (depth * 0.5 + 0.5); // invert depth\n"
"    gl_Position = projectionMatrix * viewMatrix * adjustedPosition;\n"
"    fragmentPosition = vec3(adjustedPosition.xyz); // not sure about this\n"
"    normal = calculateNormal (terrainIndex, vec2(position.xy));\n"
"}";

const char* Terrain_vert = (const char*) temp_binary_data_3;
}
